<?php
/*---------------------------------------------------------------*/
/*
    Titre : Limiter la vitesse de download                                                                                
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=462
    Date dition     : 23 Oct 2008                                                                                        
    Date mise  jour : 22 Sept 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié                                                                                    
*/
/*---------------------------------------------------------------*/

    // le fichier que vous voulez envoyer
    $local_file = 'test-file.zip';
    // le nom du fichier que l'utilisateur aura par défaut
    $download_file = 'your-download-name.zip';

    // ici vous changer la vitesse de download (=> 20,5 kb/s)
    $download_rate = 20.5;
    if(file_exists($local_file) && is_file($local_file)) {
        // send headers
        header('Cache-control: private');
        header('Content-Type: application/octet-stream');
        header('Content-Length: '.filesize($local_file));
        header('Content-Disposition: filename='.$download_file);

        // flush
        flush();
        // ouvre le fichier
        $file = fopen($local_file, "r");
        while(!feof($file)) {

            // envoie le fichier au navigateur
            print fread($file, round($download_rate * 1024));

            // flush le contenu du browser
            flush();

            // attend 1 seconde
            sleep(1);
        }

        // ferme le fichier
        fclose($file);}
    else {
        die('Error: The file '.$local_file.' does not exist!');
    }
?>